from PIL import Image, UnidentifiedImageError
from bs4 import BeautifulSoup
import numpy as np
import requests
import pandas as pd
from io import BytesIO


def loadImageFromQuery(query):
    url = f"https://searc.oliwerix.com/?q={query}&i=a"
    r = requests.get(url)
    soup = BeautifulSoup(r.text, features="lxml")
    url = soup.find_all("a", class_="result")[0].img['src']

    i = 1 
    while True:
        url = soup.find_all("a", class_="result")[i].img['src']
        i += 1

        response = requests.get(url)
        print(f"Poskus nalaganje slike iz: {url}")
        try:
            img = Image.open(BytesIO(response.content)).convert('RGB')
            print("Uspeh")
            break
        except UnidentifiedImageError:
            pass
    return img

query = input("vpisite ime slike: ")
img = loadImageFromQuery(query)
basewidth = 256
wpercent = (basewidth/float(img.size[0]))
hsize = int((float(img.size[1])*float(wpercent)))
img = img.resize((basewidth,hsize), Image.ANTIALIAS)




#img = Image.open("oliver.jpg").convert('RGB')
#img = Image.open("test2.png")
img_arr = np.array(img.getdata())

(w, h) = img.size
w *= 3 
#print(img_arr)
#print(img.size)
img_arr.shape = (h, w)
#print(img_arr)
df = pd.DataFrame(img_arr)
#print(df)
(h, w) = df.shape 
writer = pd.ExcelWriter(f"{query}.xlsx", engine='xlsxwriter')
df.to_excel(writer, sheet_name='Sheet1')
workbook  = writer.book
worksheet = writer.sheets['Sheet1']

worksheet.set_column_pixels(0, w+1, 4); worksheet.hide_row_col_headers(); worksheet.hide_gridlines(2); worksheet.set_zoom(32)
#rgb = ['#0000ff', '#ff0000', '#00ff00']
rgb = ['#ff0000', '#00ff00', '#0000ff']
#rgb = ['#ffff00', '#00ffff', '#ff00ff']
workbook.formats[0].set_font_size(2)
for x in range(w):
    worksheet.conditional_format(1, x, h, x+1,
            {'type': '2_color_scale', 'min_value': '0', 'max_value': '255', 'min_color': '#000000', 'max_color': rgb[x%3]})

  #  worksheet.conditional_format(1, x-1, h, x,
  #          {'type': '2_color_scale', 'min_color': '#000000', 'max_color': rgb[x%3]})
    
for x in range(h+1):
    worksheet.set_row_pixels(x, 12) 
# Close the Pandas Excel writer and output the Excel file.
writer.save()
print("Konec")
